
#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/ctype.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/malloc.h>
#include <linux/init.h>
#include <linux/fb.h>
#include <linux/delay.h>
#include <linux/wrapper.h>

#include <asm/hardware.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/mach-types.h>
#include <asm/uaccess.h>
#include <asm/proc/pgtable.h>

#include <video/fbcon.h>
#include <video/fbcon-mfb.h>
#include <video/fbcon-cfb4.h>
#include <video/fbcon-cfb8.h>
#include <video/fbcon-cfb16.h>

int init_module(void)
{
    printk(KERN_CRIT"disabling lcd...\n");

	LCSR = 0;	/* Clear LCD Status Register */
	LCCR0 &= ~(LCCR0_LDM);	/* Enable LCD Disable Done Interrupt */
	enable_irq(IRQ_LCD);	      /* Enable LCD IRQ */
	LCCR0 &= ~(LCCR0_LEN);	/* Disable LCD Controller */

    return 1;
}
