/*
 *  linux/drivers/video/cfb4.c -- Low level frame buffer operations for 4 bpp
 *				  packed pixels
 *
 *	Created 26 Dec 1997 by Michael Schmitz
 *	Based on the old macfb.c 4bpp code by Alan Cox
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License.  See the file COPYING in the main directory of this archive for
 *  more details.
 */
#define MODULE

#include <linux/module.h>
#include <linux/tty.h>
#include <linux/console.h>
#include <linux/string.h>
#include <linux/fb.h>

#include <video/fbcon.h>
#include <video/fbcon-cfb4.h>

volatile unsigned short *palette = NULL;
unsigned long *video = NULL;
unsigned int xSt= 0,ySt=0,xend=0,yend=0;

#ifdef MODULE
int init_module(void)
{
    int i,x,y;

    if(!palette)
        return 1;

    printk(KERN_CRIT"reading from palette @ %x\n",palette);
    for(i=0;i<16;i++)
    {
        printk("pal[%d]=%d\n",i,*(palette + i)); 
        /* printk("pal[%d]=%d\n",i + 1,*(palette + i + 1));  */
    }

    printk(KERN_CRIT"writing to palette @ %x\n",palette);

    *(palette + 0) = 15 - *(palette +0);
    *(palette + 1) = 15 - *(palette +1);
    *(palette + 2) = 15 - *(palette +2);
    *(palette + 3) = 15 - *(palette +3);
    *(palette + 4) = 15 - *(palette +4);
    *(palette + 5) = 15 - *(palette +5);
    *(palette + 6) = 15 - *(palette +6);
    *(palette + 7) = 15 - *(palette +7);
    *(palette + 8) = 15 - *(palette +8);
    *(palette + 9) = 15 - *(palette +9);
    *(palette + 10) = 15 - *(palette +10);
    *(palette + 11) = 15 - *(palette +11);
    *(palette + 12) = 15 - *(palette +12);
    *(palette + 13) = 15 - *(palette +13);
    *(palette + 14) = 15 - *(palette +14);
    *(palette + 15) = 15 - *(palette +15);

#if 0
    for(i=0;i<32;i+=2)
    {
        *(palette + i) = i/2;
        *(palette + i + 1) = 0;
    }
#endif

    return 1;
}

void cleanup_module(void)
{}
#endif /* MODULE */


    /*
     *  Visible symbols for modules
     */
MODULE_PARM(palette,"i");
