
/* converts linux logo to ppm */

#include <stdio.h>

#define __initdata
#define LINUX_LOGO_COLORS 221
#define INCLUDE_LINUX_LOGO16

#define LOGO_W 80
#define LOGO_H 80

#include <linux/linux_logo.h>

int main(int argc, char ** argv, char ** env)
{
    int i;
    FILE * fd;
    char buf[0x100];
    if(argc < 2) {
        fprintf(stderr, "Usage: %s <filename>\n", argv[0]);
        exit(1);
    }
    sprintf(buf, "%s.ppm", argv[1]);
    fd = fopen(buf, "w");
    fprintf(fd, "P6\n# Linux Logo\n%d %d\n255\n", LOGO_W, LOGO_H);
    for(i=0; i<LOGO_W*LOGO_H; i++) {
        int k=linux_logo[i]-0xFC+221-1;
        fprintf(fd, "%c%c%c",
        linux_logo_red[k], linux_logo_green[k], linux_logo_blue[k]);
    }
    fclose(fd);
    sprintf(buf, "%s16.ppm", argv[1]);
    fd = fopen(buf, "w");
    fprintf(fd, "P6\n# Linux Logo 16 colors\n%d %d\n255\n", LOGO_W, LOGO_H);
    for(i=0; i<LOGO_W*LOGO_H/2; i++) {
        int k=(linux_logo16[i]>>4);
        fprintf(fd, "%c%c%c",
        linux_logo16_red[k], linux_logo16_green[k], linux_logo16_blue[k]);
        k=(linux_logo16[i] & 0xF);
        fprintf(fd, "%c%c%c",
        linux_logo16_red[k], linux_logo16_green[k], linux_logo16_blue[k]);
    }
    fclose(fd);
    sprintf(buf, "%s.pbm", argv[1]);
    fd = fopen(buf, "w");
    fprintf(fd, "P4\n# Linux Logo BW\n%d %d\n", LOGO_W, LOGO_H);
    for(i=0; i<LOGO_W*LOGO_H/8; i++) {
        fprintf(fd, "%c", linux_logo_bw[i]);
    }
    fclose(fd);
}
